<!DOCTYPE HTML PUBLIC "-//W3O//DTD W3 HTML 2.0//EN">
<!-- This collection of hypertext pages is Copyright 1995-7 by Steve Summit. -->
<!-- This material may be freely redistributed and used -->
<!-- but may not be republished or sold without permission. -->
<html>
<head>
<link rev="owner" href="mailto:scs@eskimo.com">
<link rev="made" href="mailto:scs@eskimo.com">
<title>Chapter 25: Variable-Length Argument Lists</title>
<link href="sx10c.html" rev=precedes>
<link href="sx11a.html" rel=precedes>
<link href="top.html" rev=subdocument>
</head>
<body>
<H1>Chapter 25: Variable-Length Argument Lists</H1>

<p>
All of the functions we've written so far
have taken a fixed number of arguments,
and we've been careful to call the functions
always passing them the correct number of arguments,
and we've been tending to use
explicit function prototype declarations
so that the compiler can verify
that we call functions with the correct number of arguments.
But what about <TT>printf</TT>?
Sometimes we call it with one argument,
but often we pass it additional arguments.
Why doesn't the compiler complain?
How can <TT>printf</TT> access the extra arguments we pass to it,
when it can't know how many of them there will be
or what types they will have,
such that it can't possibly declare
conventional function parameters for them?
</p><p>In this chapter we'll discuss the <dfn>variable-length argument lists</dfn>
(often discussed under the shorthand term ``varargs'')
which allow functions such as <TT>printf</TT> to be written.
</p><p><a href="sx11a.html" rel=subdocument>25.1 Declaring ``varargs'' Functions</a></p>
<p><a href="sx11b.html" rel=subdocument>25.2 Writing a ``varargs'' Function</a></p>
<p><a href="sx11c.html" rel=subdocument>25.3 Special Issues with Varargs Functions</a></p>
<hr>
<p>
Read sequentially:
<a href="sx10c.html" rev=precedes>prev</a>
<a href="sx11a.html" rel=precedes>next</a>
<a href="top.html" rev=subdocument>up</a>
<a href="top.html">top</a>
</p>
<p>
This page by <a href="http://www.eskimo.com/~scs/">Steve Summit</a>
// <a href="copyright.html">Copyright</a> 1996-1999
// <a href="mailto:scs@eskimo.com">mail feedback</a>
</p>
</body>
</html>
